<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--
Copyright 2004-2007, U.S. Robotics Corporation
All Rights Reserved.

THIS SOFTWARE IS OFFERED "AS IS", AND U.S. Robotics GRANTS NO WARRANTIES OF ANY
KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. U.S. Robotics
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
-->
<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<title>Firewall</title>
	<link href="usr_layout.css" type="text/css" rel="stylesheet" /><script src="usr_layout.js" type="text/javascript"></script>
	<link href="usr_menus_tabbed.css" type="text/css" rel="stylesheet" /><script src="usr_menus_tabbed.js" type="text/javascript"></script><script src="usr_menus_build.js" type="text/javascript"></script>
	<link href="usr_device.css" type="text/css" rel="stylesheet" /><script src="usr_device.js" type="text/javascript"></script><script src="usr_5464.js" type="text/javascript"></script><script src="usr_resources.js" type="text/javascript"></script>
	<script type="text/javascript" src="firewall.js"></script>
</head>
<body onload="initComboboxes(); tableInitializeIAC(); tableInitializePT(); tableInitializePF();"
		onbeforeunload="verifyDeparture();">
<script type="text/javascript">
	writeHeader();
</script>
<div id="idHelpOpen" style="display: none;" onclick="setVisibility('idHelpOpen', false); setVisibility('idPanelHelp', true);">?</div>
<div id="idPanelHelp">
   <div id="idHelpClose" onclick="setVisibility('idPanelHelp', false); setVisibility('idHelpOpen', true);">x</div>
	<h1>Saving Changes</h1>
	<p>When you finish entering your changes, press the
	<strong>Save</strong> button at the bottom of the page.</p>
	<h1>Internet Access Control</h1>
	<p>In this section you can specify the days and times of the week when
	certain client devices are denied access to the Internet.
   You can also restrict certain services, such as instant messaging or games,
   by specifying the ports associated with those services.
   For example, you can deny a specific computer access to the Internet between
   10:00PM and 5:00PM during the week and between 12:00AM and 8:00AM on weekends.
	</p>
	<h1>Port Triggering</h1>
	<p>This section is where you create &ldquo;holes&rdquo; in the firewall
	to allow certain services, such as instant messaging and games, to
	communicate over the Internet.
	</p>
	<p>If you are creating an entry for a particular application, its documentation
	will provide information about the settings you need to enter here.
	</p>
	<h1>Port Forwarding</h1>
	<p>Users will typically not need to use this section.
	It&rsquo;s for directing certain inbound packets to specific ports on specific client devices.
	For example, you might use this if you host a Web server on your network.
	</p>
	<h1></h1>
	<p></p>
</div>

<script type="text/javascript">
	var dtNow = new Date("<% localtime(); %>");
	if (dtNow.getFullYear() < 2000)
	{
		document.write("<div class=\"idNotice\"><p>");
		document.write("No time server has been found. ");
		document.write("Please check your Internet connection. You can use the <a href=\"device.asp\">Device<\/a> page to specify a different time server.");
		document.write("<\/p><\/div>");
	}
</script>

<form name="idForm" action="apply.cgi" method="post">
<input type="hidden" name="page" value="firewall.asp">
<input type="hidden" name="fw_disable" value="0">
<h2>Internet Access Control</h2>
<p>Use this section to deny access to the Internet for certain client devices
during specific days and times of the week.</p>
<div id="idTableIAC">
	<!-- Content is added by script -->
</div><br/>
<table class="clsGroupBox">
	<tr><td><label for="txtIACIPfrom">LAN IP addresses:</label></td>
		<td><input type="text" id="txtIACIPfrom" class="clsSmall" size="16" maxlength="15" onchange="bDirty = true;"></td>
		<td><label for="txtIACIPto">to</label></td>
		<td><input type="text" id="txtIACIPto" class="clsSmall" size="16" maxlength="15" onchange="bDirty = true;">
		</td></tr>
	<tr><td><label>Protocol:</label></td>
		<td><select id="cbIACprotocol" class="clsSmall" onchange="bDirty = true;">
			<option value="tcp" selected>TCP</option>
			<option value="udp">UDP</option>
			</select></td>
		<td></td><td></td></tr>
	<tr><td><label for="txtPortFrom">Port range:</label></td>
		<td><input type="text" id="txtPortFrom" class="clsSmall" size="16" maxlength="5" onchange="bDirty = true;"></td>
		<td><label for="txtPortTo">to</label></td>
		<td><input type="text" id="txtPortTo" class="clsSmall" size="16" maxlength="5" onchange="bDirty = true;"></td></tr>
	<tr><td><label>Weekday range:</label></td>
		<td><select id="cbWeekdayFrom" class="clsSmall" onchange="bDirty = true;"></select></td>
		<td><label>to</label></td>
		<td><select id="cbWeekdayTo" class="clsSmall" onchange="bDirty = true;"></select></td></tr>
	<tr><td><label>Time range each day:</label></td>
		<td><select id="cbTimeFrom" class="clsSmall" onchange="bDirty = true;"></select></td>
		<td><label>to</label></td>
		<td><select id="cbTimeTo" class="clsSmall" onchange="bDirty = true;"></select></td></tr>
	<tr><td><input type="button" name="idBtnAddIAC" id="idBtnAddIAC" class="clsSmall" value=" Add " onclick="tableAddRowIAC();"></td>
		<td></td><td></td><td></td></tr>
</table>
<p id="idChangesIAC" class="clsNotice" style="display: none;">
When you finish making changes on this page, press the <strong>Save</strong>
button at the bottom of the page to save your changes to the router.</p>
<script type="text/javascript">
<!--
var objTableIAC 	= new Object;
objTableIAC.strThis	= "objTableIAC";	// the text representation of this object's name
objTableIAC.aRows	= new Array;		// the array of the row arrays for the table
function tableInitializeIAC()
{	objTableIAC.eltTable		= document.getElementById("idTableIAC");
	objTableIAC.eltBtnAdd		= document.getElementById("idBtnAddIAC");
	objTableIAC.strVarNameNum	= "filter_client";
	objTableIAC.aVarNamePrefixes	= new Array(	"filter_client_enable",
							"filter_client_from_start",
							"filter_client_from_end",
							"filter_client_proto",
							"filter_client_to_start",
							"filter_client_to_end",
							"filter_client_from_day",
							"filter_client_to_day",
							"filter_client_from_sec",
							"filter_client_to_sec"
							);
	objTableIAC.iMaxNumRows			= 30;
	objTableIAC.fctFormatRow		= fctFormatRowIAC;
	objTableIAC.aHeadings			= new Array(	"On",
								"LAN IP<br/>Addresses",
								"Protocol",
								"Destination<br/>Ports",
								"Weekdays",
								"Time Range"
							);
	var aRouterData = new Array(	"<% usr_filter_client(0); %>",
					"<% usr_filter_client(1); %>",
					"<% usr_filter_client(2); %>",
					"<% usr_filter_client(3); %>",
					"<% usr_filter_client(4); %>",
					"<% usr_filter_client(5); %>",
					"<% usr_filter_client(6); %>",
					"<% usr_filter_client(7); %>",
					"<% usr_filter_client(8); %>",
					"<% usr_filter_client(9); %>",
					"<% usr_filter_client(10); %>",
					"<% usr_filter_client(11); %>",
					"<% usr_filter_client(12); %>",
					"<% usr_filter_client(13); %>",
					"<% usr_filter_client(14); %>",
					"<% usr_filter_client(15); %>",
					"<% usr_filter_client(16); %>",
					"<% usr_filter_client(17); %>",
					"<% usr_filter_client(18); %>",
					"<% usr_filter_client(19); %>",
					"<% usr_filter_client(20); %>",
					"<% usr_filter_client(21); %>",
					"<% usr_filter_client(22); %>",
					"<% usr_filter_client(23); %>",
					"<% usr_filter_client(24); %>",
					"<% usr_filter_client(25); %>",
					"<% usr_filter_client(26); %>",
					"<% usr_filter_client(27); %>",
					"<% usr_filter_client(28); %>",
					"<% usr_filter_client(29); %>"
				);
	var re = new RegExp(reIPaddress + "-" + reIPaddress + ":" + rePortRange + "," + reProtocol + ",(\\d)-(\\d)," + reHour + "-" + reHour + ",(on|off)", "i");
	for (var row in aRouterData)
	{	if (aRouterData[row] == "-:-,,0-0,0-0,off")
			continue;
		var matches = re.exec(aRouterData[row]);
		var aRowNew = new Array(	matches[10],		// Enabled (on|off)
						matches[1],		// IP address from (start)
						matches[2],		// IP address from (end)
						matches[5],		// Protocol
						matches[3],		// Port to (start)
						matches[4],		// Port to (end)
						matches[6],		// Weekday (start) (0-6)
						matches[7],		// Weekday (end) (0-6)
						matches[8],		// Time from (start) (seconds, multiple of 3600)
						matches[9]		// Time from (end) (seconds, multiple of 3600)
					);
		objTableIAC.aRows.push(aRowNew);
	}
	tableDisplay(objTableIAC);
}
//-->
</script>
<h2>Port Triggering</h2>
<div id="idTablePT">
	<!-- Content is added by script -->
</div><br/>
<table class="clsGroupBox">
	<tr><td><label>Outbound protocol:</label></td>
		<td><select id="cbPTOutProtocol" class="clsSmall" onchange="bDirty = true;">
			<option value="tcp" selected>TCP</option>
			<option value="udp">UDP</option>
			</select></td>
		<td></td><td></td></tr>
	<tr><td><label for="txtPTOutPortFrom">Outbound port range:</label></td>
		<td><input type="text" id="txtPTOutPortFrom" class="clsSmall" size="5" maxlength="5"
				onchange="bDirty = true;"></td>
		<td><label for="txtPTOutPortTo">to</label></td>
		<td><input type="text" id="txtPTOutPortTo" class="clsSmall" size="5" maxlength="5"
				onchange="bDirty = true;"></td></tr>
	<tr><td><label>Inbound protocol:</label></td>
		<td><select id="cbPTInProtocol" class="clsSmall" onchange="bDirty = true;">
			<option value="tcp" selected>TCP</option>
			<option value="udp">UDP</option>
			</select></td><td></td><td></td></tr>
	<tr><td><label for="txtPTInPortFrom">Inbound port range:</label></td>
		<td><input type="text" id="txtPTInPortFrom" class="clsSmall" size="5" maxlength="5"
				onchange="bDirty = true;"></td>
		<td><label for="txtPTInPortTo">to</label></td>
		<td><input type="text" id="txtPTInPortTo" class="clsSmall" size="5" maxlength="5"
				onchange="bDirty = true;"></td></tr>
	<tr><td><label for="txtPTDestPortFrom">Destination port range:</label></td>
		<td><input type="text" id="txtPTDestPortFrom" class="clsSmall" size="5" maxlength="5"
				onchange="updateTo('txtPTInPortFrom', 'txtPTInPortTo', 'txtPTDestPortFrom', 'txtPTDestPortTo'); bDirty = true;"></td>
		<td><label for="txtPTDestPortTo">to</label></td>
		<td><input type="text" id="txtPTDestPortTo" class="clsSmall" size="5" maxlength="5"
				onchange="updateTo('txtPTInPortFrom', 'txtPTInPortTo', 'txtPTDestPortFrom', 'txtPTDestPortTo'); bDirty = true;"></td></tr>
	<tr><td><input type="button" name="idBtnAddPT" id="idBtnAddPT" class="clsSmall" value=" Add " onclick="tableAddRowPT();"></td>
		<td></td><td></td><td></td></tr>
</table>
<p id="idChangesPT" class="clsNotice" style="display: none;">
When you finish making changes on this page, press the <strong>Save</strong>
button at the bottom of the page to save your changes to the router.</p>
<script type="text/javascript">
<!--
var objTablePT 		= new Object;
objTablePT.strThis	= "objTablePT";	
objTablePT.aRows	= new Array;
function tableInitializePT()
{	objTablePT.eltTable		= document.getElementById("idTablePT");
	objTablePT.eltBtnAdd		= document.getElementById("idBtnAddPT");
	objTablePT.strVarNameNum	= "autofw_port";
	objTablePT.aVarNamePrefixes	= new Array(	"autofw_port_enable",
							"autofw_port_out_proto",
							"autofw_port_out_start",
							"autofw_port_out_end",
							"autofw_port_in_proto",
							"autofw_port_in_start",
							"autofw_port_in_end",
							"autofw_port_to_start",
							"autofw_port_to_end"
						);
	objTablePT.iMaxNumRows			= 30;
	objTablePT.fctFormatRow			= fctFormatRowPT;
	objTablePT.aHeadings			= new Array(	"On",
								"Outbound<br/>Protocol",
								"Ports",
								"Inbound<br/>Protocol",
								"Ports",
								"Destination Ports"
							);
	var aRouterData = new Array(	"<% usr_autofw_port(0); %>",
					"<% usr_autofw_port(1); %>",
					"<% usr_autofw_port(2); %>",
					"<% usr_autofw_port(3); %>",
					"<% usr_autofw_port(4); %>",
					"<% usr_autofw_port(5); %>",
					"<% usr_autofw_port(6); %>",
					"<% usr_autofw_port(7); %>",
					"<% usr_autofw_port(8); %>",
					"<% usr_autofw_port(9); %>",
					"<% usr_autofw_port(10); %>",
					"<% usr_autofw_port(11); %>",
					"<% usr_autofw_port(12); %>",
					"<% usr_autofw_port(13); %>",
					"<% usr_autofw_port(14); %>",
					"<% usr_autofw_port(15); %>",
					"<% usr_autofw_port(16); %>",
					"<% usr_autofw_port(17); %>",
					"<% usr_autofw_port(18); %>",
					"<% usr_autofw_port(19); %>",
					"<% usr_autofw_port(20); %>",
					"<% usr_autofw_port(21); %>",
					"<% usr_autofw_port(22); %>",
					"<% usr_autofw_port(23); %>",
					"<% usr_autofw_port(24); %>",
					"<% usr_autofw_port(25); %>",
					"<% usr_autofw_port(26); %>",
					"<% usr_autofw_port(27); %>",
					"<% usr_autofw_port(28); %>",
					"<% usr_autofw_port(29); %>"
				);
	var re = new RegExp(reProtocol + ":" + rePortRange + "," + reProtocol + ":" + rePortRange + ">" + rePortRange + ",(on|off)", "i");
	for (var row in aRouterData)
	{	if (aRouterData[row] == ":-,:->-,off")
			continue;
		var matches = re.exec(aRouterData[row]);
		var aRowNew = new Array(	matches[9],	//  Enabled (on|off)
						matches[1],	//  Protocol out
						matches[2],	//  Port out (start)
						matches[3],	//  Port out (end)
						matches[4],	//  Protocol in
						matches[5],	//  Port in (start)
						matches[6],	//  Port in (end)
						matches[7],	//  Port to (start)
						matches[8]	//  Port to (end)
					);
		objTablePT.aRows.push(aRowNew);
	}
	tableDisplay(objTablePT);
}
//-->
</script>
<h2>Port Forwarding</h2>
<div id="idTablePF">
	<!-- Content is added by script -->
</div><br/>
<table class="clsGroupBox">
	<tr><td><label>Protocol:</label></td>
		<td><select id="cbPFprotocol" class="clsSmall" onchange="bDirty = true;">
			<option value="tcp" selected>TCP</option>
			<option value="udp">UDP</option>
 			</select></td><td></td><td></td></tr>
	<tr><td><label for="txtWANportFrom">WAN port range:</label></td>
		<td><input type="text" id="txtWANportFrom" class="clsSmall" size="5" maxlength="5" onchange="bDirty = true;"></td>
		<td><label for="txtWANportTo">to</label>
		<td><input type="text" id="txtWANportTo" class="clsSmall" size="5" maxlength="5"
				onchange="updateTo('txtWANportFrom', 'txtWANportTo', 'txtLANportFrom', 'txtLANportTo'); bDirty = true;"></td></tr>
	<tr><td><label for="txtIP">LAN IP address:</label></td>
		<td colspan="3"><input type="text" id="txtIP" class="clsSmall" size="16" maxlength="15"
				onchange="updateTo('txtWANportFrom', 'txtWANportTo', 'txtLANportFrom', 'txtLANportTo'); bDirty = true;"></td></tr>
	<tr><td><label for="txtLANportFrom">LAN port range:</label></td>
		<td><input type="text" id="txtLANportFrom" class="clsSmall" size="5" maxlength="5"
				onchange="updateTo('txtWANportFrom', 'txtWANportTo', 'txtLANportFrom', 'txtLANportTo'); bDirty = true;"></td>
		<td><label for="txtLANportTo">to</label></td>
		<td><input type="text" id="txtLANportTo" class="clsSmall" size="5" maxlength="5"
				onchange="updateTo('txtWANportFrom', 'txtWANportTo', 'txtLANportFrom', 'txtLANportTo'); bDirty = true;"></td></tr>
	<tr><td><input type="button" name="idBtnAddPF" id="idBtnAddPF" class="clsSmall" value=" Add " onclick="tableAddRowPF();"></td>
		<td></td><td></td><td></td></tr>
</table>
<p id="idChangesPF" class="clsNotice" style="display: none;">
When you finish making changes on this page, press the <strong>Save</strong>
button at the bottom of the page to save your changes to the router.</p>
<script type="text/javascript">
<!--
var objTablePF 		= new Object;
objTablePF.strThis	= "objTablePF";
objTablePF.aRows	= new Array;
function tableInitializePF()
{	objTablePF.eltTable		= document.getElementById("idTablePF");
	objTablePF.eltBtnAdd		= document.getElementById("idBtnAddPF");
	objTablePF.strVarNameNum	= "forward_port";				
	objTablePF.aVarNamePrefixes	= new Array(	"forward_port_enable",
							"forward_port_proto",
							"forward_port_from_start",
							"forward_port_from_end",
							"forward_port_to_ip",
							"forward_port_to_start",
							"forward_port_to_end"
						);
	objTablePF.iMaxNumRows		= 30;
	objTablePF.fctFormatRow		= fctFormatRowPF;
	objTablePF.aHeadings		= new Array(	"On",
							"Protocol",
							"WAN Ports",
							"LAN IP Address",
							"LAN Ports"
						);
	var aRouterData = new Array(	"<% usr_forward_port(0); %>",
					"<% usr_forward_port(1); %>",
					"<% usr_forward_port(2); %>",
					"<% usr_forward_port(3); %>",
					"<% usr_forward_port(4); %>",
					"<% usr_forward_port(5); %>",
					"<% usr_forward_port(6); %>",
					"<% usr_forward_port(7); %>",
					"<% usr_forward_port(8); %>",
					"<% usr_forward_port(9); %>",
					"<% usr_forward_port(10); %>",
					"<% usr_forward_port(11); %>",
					"<% usr_forward_port(12); %>",
					"<% usr_forward_port(13); %>",
					"<% usr_forward_port(14); %>",
					"<% usr_forward_port(15); %>",
					"<% usr_forward_port(16); %>",
					"<% usr_forward_port(17); %>",
					"<% usr_forward_port(18); %>",
					"<% usr_forward_port(19); %>",
					"<% usr_forward_port(20); %>",
					"<% usr_forward_port(21); %>",
					"<% usr_forward_port(22); %>",
					"<% usr_forward_port(23); %>",
					"<% usr_forward_port(24); %>",
					"<% usr_forward_port(25); %>",
					"<% usr_forward_port(26); %>",
					"<% usr_forward_port(27); %>",
					"<% usr_forward_port(28); %>",
					"<% usr_forward_port(29); %>"
				);
	var re = new RegExp(rePortRange + ">" + reIPaddress + ":" + rePortRange + "," + reProtocol + ",(on|off)", "i");
	for (var row in aRouterData)
	{	if (aRouterData[row] == "->:-,,off")
			continue;
		var matches = re.exec(aRouterData[row]);
		var aRowNew = new Array(	matches[7],	//  Enabled (on|off)
						matches[6],	//  Protocol
						matches[1],	//  WAN port (start)
						matches[2],	//  WAN port (end)
						matches[3],	//  LAN IP Address
						matches[4],	//  LAN port (start)
						matches[5]	//  LAN port (end)
					);
		objTablePF.aRows.push(aRowNew);
	}
	tableDisplay(objTablePF);
}
//-->
</script>
<h2>Firewall</h2>
<p>The router&rsquo;s firewall (also known as stateful packet inspection or SPI)
protects your router and client devices from outside attacks.
Although you can turn it off, U.S.&nbsp;Robotics recommends that you leave it on.</p>
<p><input type="checkbox" name="chkFirewall" id="chkFirewall" <% nvram_match("fw_disable", "0", "checked"); %> onclick="bDirty = true;"> <label for="chkFirewall">Enable firewall (recommended)</label></p>
<h2>DMZ</h2>
<p>The DMZ is a client device that is outside&mdash;and not protected by&mdash;the router&rsquo;s firewall. 
If you host a public web server on a computer on your network, you might specify its IP address here.</p>
<p><label for="dmz_ipaddr">IP address:</label> <input type="text" class="clsTextfield" size="15" maxlength="15" id="dmz_ipaddr" name="dmz_ipaddr" value="<% nvram_get("dmz_ipaddr"); %>" onchange="bDirty = true;"></p>
<p class="clsSave">When you finish entering your changes, press <strong>Save</strong>.</p>
<p><input type="submit" class="clsBtnSave" name="action" value="Save" onclick="check_firewall(); bDirty=false;"></p>
</form>
<script type="text/javascript">
	writeFooter();
</script></body></html>
