<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--
Copyright 2004-2007, U.S. Robotics Corporation
All Rights Reserved.

THIS SOFTWARE IS OFFERED "AS IS", AND U.S. Robotics GRANTS NO WARRANTIES OF ANY
KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. U.S. Robotics
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
-->

<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<title>Setup</title>
	<link href="usr_layout.css" type="text/css" rel="stylesheet" /><script src="usr_layout.js" type="text/javascript"></script>
	<link href="usr_device.css" type="text/css" rel="stylesheet" /><script src="usr_device.js" type="text/javascript"></script><script src="usr_5454.js" type="text/javascript"></script><script src="usr_resources.js" type="text/javascript"></script>
	<script type="text/javascript">
<!--
function change_page() {

	with (document.forms[0]) {
		if ( wl_mode[0].checked == true ) {
			document.forms[0].action="setup_sec.asp";
		}
		else if ( wl_mode[1].checked == true ) {
			document.forms[0].action="setup_repeater.asp";
		}
		else if (wl_mode[2].checked == true) {
			document.forms[0].action="setup_wds.asp";
		}
		else if (wl_mode[3].checked == true) {
			document.forms[0].action="setup_infra.asp";
		}
	}
}

//-->
</script>
</head>

<body onload="document.idForm.optAP.focus();">

<script type="text/javascript">
	writeHeaderSetup(1, 3);
</script>


<div id="idHelpOpen" style="display: none;" onclick="setVisibility('idHelpOpen', false); setVisibility('idPanelHelp', true);">?</div>
<div id="idPanelHelp">

   <div id="idHelpClose" onclick="setVisibility('idPanelHelp', false); setVisibility('idHelpOpen', true);">x</div>

	<h1>Wireless Network Type</h1>
	<p>The access point supports three additional modes:
	range extender mode (which uses Wireless Distribution System to extend the range of your existing network),
	bridge mode (which uses Wireless Distribution System to bridge to another access point or bridge),
	and infrastructure (also known as &ldquo;client&rdquo; mode, used to connect to other access points).
	</p>
	<p><b>Range extender</b> mode is most commonly used when you want to extend the range of your existing access point.
	The access point or wireless router your range extender is connecting must support WDS.
	</p>
	<p><b>Bridge</b> mode is most commonly used when connecting your computer(s) to another 
	wired network using WDS. The wireless router or access point your bridge is connecting must support WDS.
	</p>
	<p><b>Infrastructure</b> mode is most commonly used when connecting your computer or 
	gaming console to the Internet.
	</p>

</div>


<form name="idForm" method="post" action="">
<input type="hidden" name="page" value="setup_mode.asp">


<h2>Wireless Network Type</h2>

<p>Please select the type of wireless network you want to use.
You have four choices: using the device as an access point, extending your current network using WDS, 
connecting two networks together using WDS and connecting to a wireless router or access point.
</p>

<p>
	<input type="radio" name="wl_mode" id="optAP" value="ap" checked /> <label for="optInfra">Access Point</label>	<span class="clsNote"></span><br/>
	<input type="radio" name="wl_mode" id="optRepeater" value="ap" /> <label for="optInfra">Range extender</label>	<span class="clsNote">(extends your existing network using WDS)</span><br/>
	<input type="radio" name="wl_mode" id="optWDS" value="wds"  /> <label for="optWDS">Bridge</label>	<span class="clsNote">(connects two networks using WDS)</span><br/>
	<input type="radio" name="wl_mode" id="optInfra" value="wet" /> <label for="optInfra">Infrastructure</label>	<span class="clsNote">(also known as &ldquo;client&rdquo;)</span>
</p>


<p class="clsSave">When you&rsquo;re finished and are ready to go to the next step, press <b>Next</b>.</p>

<p><input type="submit" name="btnSubmit" value="Next -->" class="clsBtnSave" onClick="change_page();"></p>

</form>

<script type="text/javascript">
	writeFooter();
</script>

</body>
</html>
